#include "AdrianSeeder_objects.h"
#include "AdrianSeeder_resources.h"
#include "built_in.h"


// T6963C module connections
char T6963C_dataPort at PORTH;
sbit T6963C_ctrlwr at RJ2_bit;
sbit T6963C_ctrlrd at RJ1_bit;
sbit T6963C_ctrlcd at RJ0_bit;
sbit T6963C_ctrlrst at RJ4_bit;
sbit T6963C_ctrlce at RJ3_bit;
sbit T6963C_ctrlfs at RJ6_bit;
sbit T6963C_ctrlmd at RJ5_bit;
sbit T6963C_ctrlwr_Direction at TRISJ2_bit;
sbit T6963C_ctrlrd_Direction at TRISJ1_bit;
sbit T6963C_ctrlcd_Direction at TRISJ0_bit;
sbit T6963C_ctrlrst_Direction at TRISJ4_bit;
sbit T6963C_ctrlce_Direction at TRISJ3_bit;
sbit T6963C_ctrlfs_Direction at TRISJ6_bit;
sbit T6963C_ctrlmd_Direction at TRISJ5_bit;

sbit BacklightRed_Direction   at TRISC2_bit;
sbit BacklightGreen_Direction at TRISC1_bit;
sbit BacklightBlue_Direction  at TRISG0_bit;
sbit BacklightRed   at RC2_bit;
sbit BacklightGreen at RC1_bit;
sbit BacklightBlue  at RG0_bit;
// End T6963C module connections

// Touch Panel module connections
sbit DriveA at LATG3_bit;
sbit DriveB at LATG4_bit;
sbit DriveA_Direction at TRISG3_bit;
sbit DriveB_Direction at TRISG4_bit;
// End Touch Panel module connections

// Global variables
unsigned int Xcoord, Ycoord;
const ADC_THRESHOLD = 900;
char PenDown;
typedef unsigned long TPointer;
TPointer PressedObject;
int PressedObjectType;
unsigned int T6963C_caption_length, T6963C_caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TButton_Round *local_round_button;
TButton_Round *exec_round_button;
int round_button_order;
TLabel *local_label;
TLabel *exec_label;
int label_order;
TCLabel *local_clabel;
TCLabel *exec_clabel;
int clabel_order;
TCBox_Round *local_round_cbox;
TCBox_Round *exec_round_cbox;
int cbox_round_order;



void Init_ADC() {
  ADCON1 = 0x0D;
  ADC_Init();
}
static void InitializeTouchPanel() {
  Init_ADC();
  T6963C_ctrlce_Direction = 0;
  T6963C_ctrlce = 0;            // Enable T6963C
  T6963C_ctrlmd_Direction = 0;
  T6963C_ctrlmd = 0;            // Column number select
  T6963C_ctrlfs_Direction = 0;
  T6963C_ctrlfs = 0;            // Wide Font

  BacklightRed_Direction   = 0; // Set backlight signals as outputs
  BacklightGreen_Direction = 0;
  BacklightBlue_Direction  = 0;
  BacklightRed   = 0;           // Turn on Red component of back light
  BacklightGreen = 0;           // Turn on Green component of back light
  BacklightBlue  = 0;           // Turn on Blue component of back light

  // Initialize T6963C
  T6963C_init(240, 128, 8);
  T6963C_graphics(1);
  T6963C_text(1);
  T6963C_cursor(0);

  TP_Init(240, 128, 0, 1);                                  // Initialize touch panel
  TP_Set_ADC_Threshold(ADC_THRESHOLD);                              // Set touch panel ADC threshold

  PenDown = 0;
  PressedObject = 0;
  PressedObjectType = -1;
}


/////////////////////////
  TScreen*  CurrentScreen;

  TScreen                Screen1;
  TCBox_Round             BoxRound1 = 
         {
         &Screen1              , //   BoxRound1.OwnerScreen
         0                     , //   BoxRound1.Order           
         87                    , //   BoxRound1.Left           
         6                     , //   BoxRound1.Top             
         50                    , //   BoxRound1.Width           
         22                    , //   BoxRound1.Height          
         1                     , //   BoxRound1.Visible         
         1                     , //   BoxRound1.Active          
         1                     , //   BoxRound1.Transparent     
         3                     , //   BoxRound1.CornerRadius           
         0                     , //   BoxRound1.OnUpPtr
         0                     , //   BoxRound1.OnDownPtr
         0                     , //   BoxRound1.OnClickPtr
         0                       //   BoxRound1.OnPressPtr
         };
  TCBox_Round             BoxRound2 = 
         {
         &Screen1              , //   BoxRound2.OwnerScreen
         1                     , //   BoxRound2.Order           
         180                   , //   BoxRound2.Left           
         6                     , //   BoxRound2.Top             
         51                    , //   BoxRound2.Width           
         22                    , //   BoxRound2.Height          
         1                     , //   BoxRound2.Visible         
         1                     , //   BoxRound2.Active          
         1                     , //   BoxRound2.Transparent     
         3                     , //   BoxRound2.CornerRadius           
         0                     , //   BoxRound2.OnUpPtr
         0                     , //   BoxRound2.OnDownPtr
         0                     , //   BoxRound2.OnClickPtr
         0                       //   BoxRound2.OnPressPtr
         };
  TCLabel          Label1 = 
         {
         &Screen1              , //   Label1.OwnerScreen
         2                     , //   Label1.Order          
         182                   , //   Label1.Left           
         4                     , //   Label1.Top             
         43                    , //   Label1.Width         
         25                    , //   Label1.Height       
         &Label1_Caption       , //   Label1.Caption        
         &Tahoma19x23_Regular  , //   Label1.FontName       
         T6963C_WHITE          , //   Label1.Font_Color     
         1                     , //   Label1.Visible        
         1                     , //   Label1.Active        
         0                     , //   Label1.OnUpPtr
         0                     , //   Label1.OnDownPtr
         0                     , //   Label1.OnClickPtr
         0                       //   Label1.OnPressPtr
         };
const char Label1_Caption[5] = "2500";

  TCLabel          Label2 = 
         {
         &Screen1              , //   Label2.OwnerScreen
         3                     , //   Label2.Order          
         91                    , //   Label2.Left           
         4                     , //   Label2.Top             
         43                    , //   Label2.Width         
         25                    , //   Label2.Height       
         &Label2_Caption       , //   Label2.Caption        
         &Tahoma19x23_Regular  , //   Label2.FontName       
         T6963C_WHITE          , //   Label2.Font_Color     
         1                     , //   Label2.Visible        
         1                     , //   Label2.Active        
         0                     , //   Label2.OnUpPtr
         0                     , //   Label2.OnDownPtr
         0                     , //   Label2.OnClickPtr
         0                       //   Label2.OnPressPtr
         };
const char Label2_Caption[5] = "2260";

  TButton_Round          PauseButton;
char PauseButton_Caption[6] = "Pause";

  TButton_Round          ResetCounterButton;
char ResetCounterButton_Caption[14] = "Reset Counter";

  TCLabel          Label6 = 
         {
         &Screen1              , //   Label6.OwnerScreen
         6                     , //   Label6.Order          
         142                   , //   Label6.Left           
         15                    , //   Label6.Top             
         24                    , //   Label6.Width         
         12                    , //   Label6.Height       
         &Label6_Caption       , //   Label6.Caption        
         &T6963C_defaultFont   , //   Label6.FontName       
         T6963C_WHITE          , //   Label6.Font_Color     
         1                     , //   Label6.Visible        
         1                     , //   Label6.Active        
         0                     , //   Label6.OnUpPtr
         0                     , //   Label6.OnDownPtr
         0                     , //   Label6.OnClickPtr
         0                       //   Label6.OnPressPtr
         };
const char Label6_Caption[6] = "Width";

  TCLabel          Label7 = 
         {
         &Screen1              , //   Label7.OwnerScreen
         7                     , //   Label7.Order          
         1                     , //   Label7.Left           
         10                    , //   Label7.Top             
         80                    , //   Label7.Width         
         12                    , //   Label7.Height       
         &Label7_Caption       , //   Label7.Caption        
         &T6963C_defaultFont   , //   Label7.FontName       
         T6963C_WHITE          , //   Label7.Font_Color     
         1                     , //   Label7.Visible        
         1                     , //   Label7.Active        
         0                     , //   Label7.OnUpPtr
         0                     , //   Label7.OnDownPtr
         0                     , //   Label7.OnClickPtr
         0                       //   Label7.OnPressPtr
         };
const char Label7_Caption[19] = "Tyre Circumference";

  TCLabel          Label8 = 
         {
         &Screen1              , //   Label8.OwnerScreen
         8                     , //   Label8.Order          
         6                     , //   Label8.Left           
         40                    , //   Label8.Top             
         50                    , //   Label8.Width         
         12                    , //   Label8.Height       
         &Label8_Caption       , //   Label8.Caption        
         &T6963C_defaultFont   , //   Label8.FontName       
         T6963C_WHITE          , //   Label8.Font_Color     
         1                     , //   Label8.Visible        
         1                     , //   Label8.Active        
         0                     , //   Label8.OnUpPtr
         0                     , //   Label8.OnDownPtr
         0                     , //   Label8.OnClickPtr
         0                       //   Label8.OnPressPtr
         };
const char Label8_Caption[11] = "Km Covered";

  TCLabel          Label9 = 
         {
         &Screen1              , //   Label9.OwnerScreen
         9                     , //   Label9.Order          
         6                     , //   Label9.Left           
         60                    , //   Label9.Top             
         46                    , //   Label9.Width         
         12                    , //   Label9.Height       
         &Label9_Caption       , //   Label9.Caption        
         &T6963C_defaultFont   , //   Label9.FontName       
         T6963C_WHITE          , //   Label9.Font_Color     
         1                     , //   Label9.Visible        
         1                     , //   Label9.Active        
         0                     , //   Label9.OnUpPtr
         0                     , //   Label9.OnDownPtr
         0                     , //   Label9.OnClickPtr
         0                       //   Label9.OnPressPtr
         };
const char Label9_Caption[11] = "Ac Covered";

  TCLabel          Label10 = 
         {
         &Screen1              , //   Label10.OwnerScreen
         10                    , //   Label10.Order          
         6                     , //   Label10.Left           
         80                    , //   Label10.Top             
         47                    , //   Label10.Width         
         12                    , //   Label10.Height       
         &Label10_Caption      , //   Label10.Caption        
         &T6963C_defaultFont   , //   Label10.FontName       
         T6963C_WHITE          , //   Label10.Font_Color     
         1                     , //   Label10.Visible        
         1                     , //   Label10.Active        
         0                     , //   Label10.OnUpPtr
         0                     , //   Label10.OnDownPtr
         0                     , //   Label10.OnClickPtr
         0                       //   Label10.OnPressPtr
         };
const char Label10_Caption[11] = "Ha Covered";

  TCLabel          Label3 = 
         {
         &Screen1              , //   Label3.OwnerScreen
         11                    , //   Label3.Order          
         142                   , //   Label3.Left           
         3                     , //   Label3.Top             
         34                    , //   Label3.Width         
         12                    , //   Label3.Height       
         &Label3_Caption       , //   Label3.Caption        
         &T6963C_defaultFont   , //   Label3.FontName       
         T6963C_WHITE          , //   Label3.Font_Color     
         1                     , //   Label3.Visible        
         1                     , //   Label3.Active        
         0                     , //   Label3.OnUpPtr
         0                     , //   Label3.OnDownPtr
         0                     , //   Label3.OnClickPtr
         0                       //   Label3.OnPressPtr
         };
const char Label3_Caption[8] = "Machine";

  TLabel                 Km_Box_Text;
char Km_Box_Text_Caption[31] = "0";

  TLabel                 Acres_box_text;
char acres_box_text_Caption[31] = "0";

  TLabel                 Hectares_box_text;
char hectares_box_text_Caption[31] = "0";

  TButton_Round          Resume_Button;
char Resume_Button_Caption[7] = "Resume";

  TButton_Round          * const code Screen1_Buttons_Round[3]=
         {
         &PauseButton,         
         &ResetCounterButton,  
         &Resume_Button        
         };
  TLabel                 * const code Screen1_Labels[3]=
         {
         &Km_Box_Text,         
         &Acres_box_text,
         &Hectares_box_text
         };
  TCLabel                 * const code Screen1_CLabels[8]=
         {
         &Label1,              
         &Label2,              
         &Label6,              
         &Label7,              
         &Label8,              
         &Label9,              
         &Label10,             
         &Label3               
         };
  TCBox_Round             * const code Screen1_CBoxes_Round[2]=
         {
         &BoxRound1,           
         &BoxRound2            
         };




static void InitializeObjects() {
  Screen1.Buttons_RoundCount        = 3;
  Screen1.Buttons_Round             = Screen1_Buttons_Round;
  Screen1.LabelsCount               = 3;
  Screen1.Labels                    = Screen1_Labels;
  Screen1.CLabelsCount              = 8;
  Screen1.CLabels                   = Screen1_CLabels;
  Screen1.CBoxes_RoundCount         = 2;
  Screen1.CBoxes_Round              = Screen1_CBoxes_Round;
  Screen1.ObjectsCount              = 16;


  PauseButton.OwnerScreen     = &Screen1;
  PauseButton.Order           = 4;
  PauseButton.Left            = 90;
  PauseButton.Top             = 99;
  PauseButton.Width           = 69;
  PauseButton.Height          = 23;
  PauseButton.Visible         = 1;
  PauseButton.Active          = 1;
  PauseButton.Caption         = PauseButton_Caption;
  PauseButton.TextAlign       = _taCenter;
  PauseButton.FontName        = T6963C_defaultFont;
  PauseButton.PressColEnabled = 1;
  PauseButton.Corner_Radius   = 3;
  PauseButton.OnUpPtr         = 0;
  PauseButton.OnDownPtr       = 0;
  PauseButton.OnClickPtr      = 0;
  PauseButton.OnPressPtr      = PauseButtonOnPress;

  ResetCounterButton.OwnerScreen     = &Screen1;
  ResetCounterButton.Order           = 5;
  ResetCounterButton.Left            = 7;
  ResetCounterButton.Top             = 99;
  ResetCounterButton.Width           = 77;
  ResetCounterButton.Height          = 23;
  ResetCounterButton.Visible         = 1;
  ResetCounterButton.Active          = 1;
  ResetCounterButton.Caption         = ResetCounterButton_Caption;
  ResetCounterButton.TextAlign       = _taCenter;
  ResetCounterButton.FontName        = T6963C_defaultFont;
  ResetCounterButton.PressColEnabled = 1;
  ResetCounterButton.Corner_Radius   = 3;
  ResetCounterButton.OnUpPtr         = 0;
  ResetCounterButton.OnDownPtr       = 0;
  ResetCounterButton.OnClickPtr      = 0;
  ResetCounterButton.OnPressPtr      = ResetCounterButtonOnPress;

  Km_Box_Text.OwnerScreen     = &Screen1;
  Km_Box_Text.Order           = 12;
  Km_Box_Text.Left            = 85;
  Km_Box_Text.Top             = 32;
  Km_Box_Text.Width           = 9;
  Km_Box_Text.Height          = 21;
  Km_Box_Text.Visible         = 1;
  Km_Box_Text.Active          = 1;
  Km_Box_Text.Caption         = Km_Box_Text_Caption;
  Km_Box_Text.FontName        = Tahoma16x19_Regular;
  Km_Box_Text.Font_Color      = T6963C_WHITE;
  Km_Box_Text.OnUpPtr         = 0;
  Km_Box_Text.OnDownPtr       = 0;
  Km_Box_Text.OnClickPtr      = 0;
  Km_Box_Text.OnPressPtr      = 0;

  acres_box_text.OwnerScreen     = &Screen1;
  acres_box_text.Order           = 13;
  acres_box_text.Left            = 85;
  acres_box_text.Top             = 54;
  acres_box_text.Width           = 9;
  acres_box_text.Height          = 21;
  acres_box_text.Visible         = 1;
  acres_box_text.Active          = 1;
  acres_box_text.Caption         = Acres_box_text_Caption;
  acres_box_text.FontName        = Tahoma16x19_Regular;
  acres_box_text.Font_Color      = T6963C_WHITE;
  acres_box_text.OnUpPtr         = 0;
  acres_box_text.OnDownPtr       = 0;
  acres_box_text.OnClickPtr      = 0;
  acres_box_text.OnPressPtr      = 0;

  hectares_box_text.OwnerScreen     = &Screen1;
  hectares_box_text.Order           = 14;
  hectares_box_text.Left            = 85;
  hectares_box_text.Top             = 75;
  hectares_box_text.Width           = 9;
  hectares_box_text.Height          = 21;
  hectares_box_text.Visible         = 1;
  hectares_box_text.Active          = 1;
  hectares_box_text.Caption         = Hectares_box_text_Caption;
  hectares_box_text.FontName        = Tahoma16x19_Regular;
  hectares_box_text.Font_Color      = T6963C_WHITE;
  hectares_box_text.OnUpPtr         = 0;
  hectares_box_text.OnDownPtr       = 0;
  hectares_box_text.OnClickPtr      = 0;
  hectares_box_text.OnPressPtr      = 0;

  Resume_Button.OwnerScreen     = &Screen1;
  Resume_Button.Order           = 15;
  Resume_Button.Left            = 164;
  Resume_Button.Top             = 99;
  Resume_Button.Width           = 69;
  Resume_Button.Height          = 23;
  Resume_Button.Visible         = 1;
  Resume_Button.Active          = 1;
  Resume_Button.Caption         = Resume_Button_Caption;
  Resume_Button.TextAlign       = _taCenter;
  Resume_Button.FontName        = T6963C_defaultFont;
  Resume_Button.PressColEnabled = 1;
  Resume_Button.Corner_Radius   = 3;
  Resume_Button.OnUpPtr         = 0;
  Resume_Button.OnDownPtr       = 0;
  Resume_Button.OnClickPtr      = 0;
  Resume_Button.OnPressPtr      = ResumeButtonOnPress;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) { // static
  if ( (Left<= X) && (Left+ Width - 1 >= X) &&
       (Top <= Y)  && (Top + Height - 1 >= Y) )
    return 1;
  else
    return 0;
}


#define GetRoundButton(index)         CurrentScreen->Buttons_Round[index]
#define GetLabel(index)               CurrentScreen->Labels[index]
#define GetCLabel(index)              CurrentScreen->CLabels[index]
#define GetCBox_Round(index)          CurrentScreen->CBoxes_Round[index]


void DrawRoundButton(TButton_Round *Around_button) {

  if (Around_button->Visible == 1) {
    if (object_pressed == 1) {
      object_pressed = 0;
      T6963C_Rectangle_Round_Edges(Around_button->Left - 1, Around_button->Top - 1,
        Around_button->Left + Around_button->Width,
        Around_button->Top + Around_button->Height, Around_button->Corner_Radius, T6963C_WHITE);
      T6963C_Rectangle_Round_Edges(Around_button->Left, Around_button->Top,
        Around_button->Left + Around_button->Width - 1,
        Around_button->Top + Around_button->Height - 1, Around_button->Corner_Radius, T6963C_BLACK);
      T6963C_Rectangle_Round_Edges_Fill(Around_button->Left + 1, Around_button->Top + 1,
        Around_button->Left + Around_button->Width - 2,
        Around_button->Top + Around_button->Height - 2, Around_button->Corner_Radius, T6963C_WHITE);
    }
    else {
      T6963C_Rectangle_Round_Edges(Around_button->Left - 1, Around_button->Top - 1,
        Around_button->Left + Around_button->Width,
        Around_button->Top + Around_button->Height, Around_button->Corner_Radius, T6963C_BLACK);
      T6963C_Rectangle_Round_Edges_Fill(Around_button->Left, Around_button->Top,
        Around_button->Left + Around_button->Width - 1,
        Around_button->Top + Around_button->Height - 1, Around_button->Corner_Radius, T6963C_WHITE);
      if ((Around_button->Width >= 5) && (Around_button->Height >= 5)) {
        T6963C_Rectangle_Round_Edges(Around_button->Left + 1, Around_button->Top + 1,
          Around_button->Left + Around_button->Width - 2,
          Around_button->Top + Around_button->Height - 2, Around_button->Corner_Radius, T6963C_BLACK);
      }
    }
    T6963C_Set_Font_Adv(Around_button->FontName, T6963C_BLACK, _T6963C_HORIZONTAL);
    T6963C_Write_Text_Return_Pos(Around_button->Caption, Around_button->Left, Around_button->Top);
    if (Around_button->TextAlign == _taLeft)
      T6963C_Write_Text_Adv(Around_button->Caption, Around_button->Left + 3, (Around_button->Top + ((Around_button->Height - T6963C_caption_height) / 2)));
    else if (Around_button->TextAlign == _taCenter)
      T6963C_Write_Text_Adv(Around_button->Caption, (Around_button->Left + (Around_button->Width - T6963C_caption_length) / 2), (Around_button->Top + ((Around_button->Height - T6963C_caption_height) / 2)));
    else if (Around_button->TextAlign == _taRight)
      T6963C_Write_Text_Adv(Around_button->Caption, Around_button->Left + (Around_button->Width - T6963C_caption_length - 4), (Around_button->Top + ((Around_button->Height - T6963C_caption_height) / 2)));
  }
}

void DrawLabel(TLabel *ALabel) {
  if (ALabel->Visible == 1) {
    T6963C_Set_Font_Adv(ALabel->FontName, ALabel->Font_Color, _T6963C_HORIZONTAL);
    T6963C_Write_Text_Adv(ALabel->Caption, ALabel->Left, ALabel->Top);
  }
}

void DrawCLabel(TCLabel *ALabel) {
  if (ALabel->Visible == 1) {
    T6963C_Set_Font_Adv(ALabel->FontName, ALabel->Font_Color, _T6963C_HORIZONTAL);
    T6963C_Write_Const_Text_Adv(ALabel->Caption, ALabel->Left, ALabel->Top);
  }
}

void DrawCRoundBox(TCBox_Round *Around_box) {
  if (Around_box->Visible == 1) {
    if (Around_box->Transparent == 1) {
      T6963C_Rectangle_Round_Edges(Around_box->Left, Around_box->Top,
        Around_box->Left + Around_box->Width - 1,
        Around_box->Top + Around_box->Height - 1,
        Around_box->Corner_Radius, T6963C_WHITE);
    }
    else {
      T6963C_Rectangle_Round_Edges_Fill(Around_box->Left, Around_box->Top,
        Around_box->Left + Around_box->Width - 1,
        Around_box->Top + Around_box->Height - 1,
        Around_box->Corner_Radius, T6963C_WHITE);
    }
  }
}

void DrawScreen(TScreen *aScreen) {
 int order;
  unsigned short round_button_idx;
  TButton_Round *local_round_button;
  unsigned short label_idx;
  TLabel *local_label;
  unsigned short clabel_idx;
  TCLabel *local_clabel;
  unsigned short round_cbox_idx;
  TCBox_Round *local_round_cbox;

  object_pressed = 0;
  order = 0;
  round_button_idx = 0;
  label_idx = 0;
  clabel_idx = 0;
  round_cbox_idx = 0;
  CurrentScreen = aScreen;

  T6963C_grFill(0);
  T6963C_txtFill(0);

  while (order < CurrentScreen->ObjectsCount) {
    if (round_button_idx < CurrentScreen->Buttons_RoundCount) {
      local_round_button = GetRoundButton(round_button_idx);
      if (order == local_round_button->Order) {
        order++;
        round_button_idx++;
        DrawRoundButton(local_round_button);
      }
    }

    if (label_idx < CurrentScreen->LabelsCount) {
      local_label = GetLabel(label_idx);
      if (order == local_label->Order) {
        label_idx++;
        order++;
        DrawLabel(local_label);
      }
    }

    if (clabel_idx < CurrentScreen->CLabelsCount) {
      local_clabel = GetCLabel(clabel_idx);
      if (order == local_clabel->Order) {
        clabel_idx++;
        order++;
        DrawCLabel(local_clabel);
      }
    }

    if (round_cbox_idx < CurrentScreen->CBoxes_RoundCount) {
      local_round_cbox = GetCBox_Round(round_cbox_idx);
      if (order == local_round_cbox->Order) {
        round_cbox_idx++;
        order++;
        DrawCRoundBox(local_round_cbox);
      }
    }

  }
}

void Get_Object(unsigned int X, unsigned int Y) {
  round_button_order  = -1;
  label_order         = -1;
  clabel_order        = -1;
  cbox_round_order    = -1;
  //  Buttons with Round Edges
  for ( _object_count = 0 ; _object_count < CurrentScreen->Buttons_RoundCount ; _object_count++ ) {
    local_round_button = GetRoundButton(_object_count);
    if (local_round_button->Active == 1) {
      if (IsInsideObject(X, Y, local_round_button->Left, local_round_button->Top,
                         local_round_button->Width, local_round_button->Height) == 1) {
        round_button_order = local_round_button->Order;
        exec_round_button = local_round_button;
      }
    }
  }

  //  Labels
  for ( _object_count = 0 ; _object_count < CurrentScreen->LabelsCount ; _object_count++ ) {
    local_label = GetLabel(_object_count);
    if (local_label->Active == 1) {
      if (IsInsideObject(X, Y, local_label->Left, local_label->Top,
                         local_label->Width, local_label->Height) == 1) {
        label_order = local_label->Order;
        exec_label = local_label;
      }
    }
  }

  //  CLabels
  for ( _object_count = 0 ; _object_count < CurrentScreen->CLabelsCount ; _object_count++ ) {
    local_clabel = GetCLabel(_object_count);
    if (local_clabel->Active == 1) {
      if (IsInsideObject(X, Y, local_clabel->Left, local_clabel->Top,
                         local_clabel->Width, local_clabel->Height) == 1) {
        clabel_order = local_clabel->Order;
        exec_clabel = local_clabel;
      }
    }
  }

  //  CBoxes with Round Edges
  for ( _object_count = 0 ; _object_count < CurrentScreen->CBoxes_RoundCount ; _object_count++ ) {
    local_round_cbox = GetCBox_Round(_object_count);
    if (local_round_cbox->Active == 1) {
      if (IsInsideObject(X, Y, local_round_cbox->Left, local_round_cbox->Top,
                         local_round_cbox->Width, local_round_cbox->Height) == 1) {
        cbox_round_order = local_round_cbox->Order;
        exec_round_cbox = local_round_cbox;
      }
    }
  }

  _object_count = -1;
  if (round_button_order > _object_count)
    _object_count = round_button_order;
  if (label_order >  _object_count )
    _object_count = label_order;
  if (clabel_order >  _object_count )
    _object_count = clabel_order;
  if (cbox_round_order >  _object_count )
    _object_count = cbox_round_order;
}


static void Process_TP_Press(unsigned int X, unsigned int Y) {
  exec_round_button   = 0;
  exec_label          = 0;
  exec_clabel         = 0;
  exec_round_cbox     = 0;

  Get_Object(X, Y);


  if (_object_count != -1) {
    if (_object_count == round_button_order) {
      if (exec_round_button->Active == 1) {
        if (exec_round_button->OnPressPtr != 0) {
          exec_round_button->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == label_order) {
      if (exec_label->Active == 1) {
        if (exec_label->OnPressPtr != 0) {
          exec_label->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == clabel_order) {
      if (exec_clabel->Active == 1) {
        if (exec_clabel->OnPressPtr != 0) {
          exec_clabel->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == cbox_round_order) {
      if (exec_round_cbox->Active == 1) {
        if (exec_round_cbox->OnPressPtr != 0) {
          exec_round_cbox->OnPressPtr();
          return;
        }
      }
    }

  }
}

static void Process_TP_Up(unsigned int X, unsigned int Y) {

  switch (PressedObjectType) {
    // Round Button
    case 1: {
      if (PressedObject != 0) {
        exec_round_button = (TButton_Round*)PressedObject;
        if ((exec_round_button->PressColEnabled == 1) && (exec_round_button->OwnerScreen == CurrentScreen)) {
          DrawRoundButton(exec_round_button);
        }
        break;
      }
      break;
    }
    // CRound Box
    case 15: {
      if (PressedObject != 0) {
        exec_round_cbox = (TCBox_Round*)PressedObject;
      }
      break;
    }
  }

  exec_label          = 0;
  exec_clabel          = 0;

  Get_Object(X, Y);


  if (_object_count != -1) {
  // Buttons with Round Edges
    if (_object_count == round_button_order) {
      if (exec_round_button->Active == 1) {
        if (exec_round_button->OnUpPtr != 0)
          exec_round_button->OnUpPtr();
        if (PressedObject == (TPointer)exec_round_button)
          if (exec_round_button->OnClickPtr != 0)
            exec_round_button->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Labels
    if (_object_count == label_order) {
      if (exec_label->Active == 1) {
        if (exec_label->OnUpPtr != 0)
          exec_label->OnUpPtr();
        if (PressedObject == (TPointer)exec_label)
          if (exec_label->OnClickPtr != 0)
            exec_label->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // CLabels
    if (_object_count == clabel_order) {
      if (exec_clabel->Active == 1) {
        if (exec_clabel->OnUpPtr != 0)
          exec_clabel->OnUpPtr();
        if (PressedObject == (TPointer)exec_clabel)
          if (exec_clabel->OnClickPtr != 0)
            exec_clabel->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // CBoxes with Round Edges
    if (_object_count == cbox_round_order) {
      if (exec_round_cbox->Active == 1) {
        if (exec_round_cbox->OnUpPtr != 0)
          exec_round_cbox->OnUpPtr();
        if (PressedObject == (TPointer)exec_round_cbox)
          if (exec_round_cbox->OnClickPtr != 0)
            exec_round_cbox->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  }
  PressedObject = 0;
  PressedObjectType = -1;
}

static void Process_TP_Down(unsigned int X, unsigned int Y) {

  object_pressed      = 0;
  exec_round_button   = 0;
  exec_label          = 0;
  exec_clabel         = 0;
  exec_round_cbox     = 0;

  Get_Object(X, Y);

  if (_object_count != -1) {
    if (_object_count == round_button_order) {
      if (exec_round_button->Active == 1) {
        if (exec_round_button->PressColEnabled == 1) {
          object_pressed = 1;
          DrawRoundButton(exec_round_button);
        }
        PressedObject = (TPointer)exec_round_button;
        PressedObjectType = 1;
        if (exec_round_button->OnDownPtr != 0) {
          exec_round_button->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == label_order) {
      if (exec_label->Active == 1) {
        PressedObject = (TPointer)exec_label;
        PressedObjectType = 2;
        if (exec_label->OnDownPtr != 0) {
          exec_label->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == clabel_order) {
      if (exec_clabel->Active == 1) {
        PressedObject = (TPointer)exec_clabel;
        PressedObjectType = 10;
        if (exec_clabel->OnDownPtr != 0) {
          exec_clabel->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == cbox_round_order) {
      if (exec_round_cbox->Active == 1) {
        PressedObject = (TPointer)exec_round_cbox;
        PressedObjectType = 15;
        if (exec_round_cbox->OnDownPtr != 0) {
          exec_round_cbox->OnDownPtr();
          return;
        }
      }
    }

  }
}

void Check_TP() {
  if (TP_Press_Detect()) {
    // After a PRESS is detected read X-Y and convert it to Display dimensions space
    if (TP_Get_Coordinates(&Xcoord, &Ycoord) == 0) {
      Process_TP_Press(Xcoord, Ycoord);
      if (PenDown == 0) {
        PenDown = 1;
        Process_TP_Down(Xcoord, Ycoord);
      }
    }
  }
  else if (PenDown == 1) {
    PenDown = 0;
    Process_TP_Up(Xcoord, Ycoord);
  }
}

void Init_MCU() {
  // Place your code here
}

void Start_TP() {
  Init_MCU();

  InitializeTouchPanel();

  // You can get calibration constants using touch panel calibration example
  TP_Set_Calibration_Consts(48, 947, 88, 898);    // Set calibration constants

  InitializeObjects();
  DrawScreen(&Screen1);
}