/*
 * Project name:
     AdrianSeeder.vglcd
 * Generated by:
     Visual GLCD
 * Date of creation
     12/04/2014
 * Time of creation
     1:49:41 PM
 * Test configuration:
     MCU:             P18F8722
     Dev.Board:       SmartGLCD240x128_hw_rev_1.50
                      http://www.mikroe.com/eng/products/view/443/smartglcd-240x128-board/
     Oscillator:      40000000 Hz
     SW:              mikroC PRO for PIC
                      http://www.mikroe.com/eng/products/view/7/mikroc-pro-for-pic/
 */

#include "AdrianSeeder_objects.h"
extern void update_boxes(void);
char temp;
char outstr[30];
unsigned long current_count;
float km_traveled ;
float acres_covered;
float hectares_covered;
bit upd_flag;

/* Area calculations: Assuming that 1 pulse = 2.26 Mtrs 0.00226 Km
                       (Wheel circumference)

                       So 1 pulse x 0.00226 gives the result in kilometers
                       1 pulse from the sensor = 5.65 sq Mtrs due to
                       machine width being 2.5 Mtrs wide (2.260 x 2.500 = 5.56)

                       Then 1 Ha = 10000 sq Mtrs, so 1 pulse = 0.000556 Ha
                       So like above 1 pulse x 0.000556 gives the result in Ha.

                       Using this I then multiply  the Hectare rate by the acre
                       conversion factor of 2.47105 x hectares_covered to
                       achieve the acres covered.
 */

void calculate_convert(void){
  km_traveled = (0.00226 * current_count);
  hectares_covered = (0.00056 * current_count );
  acres_covered = (2.47105 * hectares_covered);
 }

 /**************************************************************************************************
* Interrupt routine
**************************************************************************************************/


void interrupt() iv 0x0008 ics ICS_AUTO {
     if(INTCON.INT0IF = 1){
       current_count++;
       upd_flag = 1;
       INTCON.INT0IF = 0;        // Clear interrupt flag
       }
}
 
void main() {

    TRISB = 0xFF;         // PORTB as input
    INTCON2.RBPU = 0;     // Turn on port B Pullups
    INTCON.INT0IF = 0;     // Clear interrupt flag prior to enable
    INTCON2.INTEDG0 = 0;   // 1 = Rising Edge 0 = Falling Edge
    INTCON.GIEL  = 1;     // enable Global interrupts
    INTCON.GIEH  = 1;     // enable Global interrupts
  upd_flag = 0;
  current_count = 0;

  Start_TP();

  while (1) {
    Check_TP();
    if(upd_flag == 1)update_boxes();

  }

}