#include "__T6963C.h"
enum GlcdColor {_clClear, _clDraw, _clInvert};
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct  Button_Round {
  TScreen*  OwnerScreen;
  char          Order;
  char          Left;
  char          Top;
  char          Width;
  char          Height;
  char          Visible;
  char          Active;
  char          *Caption;
  TTextAlign    TextAlign;
  const char    *FontName;
  char          Corner_Radius;
  char          PressColEnabled;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TButton_Round;

typedef struct  Label {
  TScreen*  OwnerScreen;
  char          Order;
  char          Left;
  char          Top;
  char          Width;
  char          Height;
  char          *Caption;
  const char    *FontName;
  unsigned char Font_Color;
  char          Visible;
  char          Active;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TLabel;

typedef const struct  CLabel {
  TScreen*  OwnerScreen;
  char          Order;
  char          Left;
  char          Top;
  char          Width;
  char          Height;
  const char          *Caption;
  const char    *FontName;
  unsigned char Font_Color;
  char          Visible;
  char          Active;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TCLabel;

typedef const struct  CBox_Round {
  TScreen*  OwnerScreen;
  char          Order;
  char          Left;
  char          Top;
  char          Width;
  char          Height;
  char          Visible;
  char          Active;
  char          Transparent;
  char          Corner_Radius;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TCBox_Round;

struct Screen {
  unsigned short         ObjectsCount;
  unsigned int           Buttons_RoundCount;
  TButton_Round          * const code *Buttons_Round;
  unsigned int           LabelsCount;
  TLabel                 * const code *Labels;
  unsigned int           CLabelsCount;
  TCLabel                 * const code *CLabels;
  unsigned int           CBoxes_RoundCount;
  TCBox_Round             * const code *CBoxes_Round;
};

extern   TScreen                Screen1;
extern   TCBox_Round             BoxRound1;
extern   TCBox_Round             BoxRound2;
extern   TCLabel          Label1;
extern   TCLabel          Label2;
extern   TButton_Round          PauseButton;
extern   TButton_Round          ResetCounterButton;
extern   TCLabel          Label6;
extern   TCLabel          Label7;
extern   TCLabel          Label8;
extern   TCLabel          Label9;
extern   TCLabel          Label10;
extern   TCLabel          Label3;
extern   TLabel                 Km_Box_Text;
extern   TLabel                 acres_box_text;
extern   TLabel                 hectares_box_text;
extern   TButton_Round          Resume_Button;
extern   TButton_Round          * const code Screen1_Buttons_Round[3];
extern   TLabel                 * const code Screen1_Labels[3];
extern   TCLabel                 * const code Screen1_CLabels[8];
extern   TCBox_Round             * const code Screen1_CBoxes_Round[2];



/////////////////////////
// Events Code Declarations
void PauseButtonOnPress();
void ResetCounterButtonOnPress();
void ResumeButtonOnPress();
/////////////////////////

/////////////////////////////////
// Caption variables Declarations
extern const char BoxRound1_Caption[];
extern const char BoxRound2_Caption[];
extern const char Label1_Caption[];
extern const char Label2_Caption[];
extern char PauseButton_Caption[];
extern char ResetCounterButton_Caption[];
extern const char Label6_Caption[];
extern const char Label7_Caption[];
extern const char Label8_Caption[];
extern const char Label9_Caption[];
extern const char Label10_Caption[];
extern const char Label3_Caption[];
extern char Km_Box_Text_Caption[];
extern char acres_box_text_Caption[];
extern char hectares_box_text_Caption[];
extern char Resume_Button_Caption[];
/////////////////////////////////

void DrawScreen(TScreen *aScreen);
void DrawRoundButton(TButton_Round *Around_button);
void DrawLabel(TLabel *ALabel);
void DrawCLabel(TCLabel *AClabel);
void DrawCRoundBox(TCBox_Round *ACround_box);
void Check_TP();
void Start_TP();
